Grass = {}
Grass.__index = Grass
ActiveGrass = {}

function Grass.new(x,y,width,height)
   local instance = setmetatable({}, Grass)
   instance.x = x
   instance.y = y
   instance.isContact = false

   instance.physics = {}
   instance.physics.body = love.physics.newBody(World, instance.x, instance.y, "static")
   instance.physics.shape = love.physics.newRectangleShape(width, height)
   instance.physics.fixture = love.physics.newFixture(instance.physics.body, instance.physics.shape)
   instance.physics.fixture:setSensor(true)
   table.insert(ActiveGrass, instance)
end

function Grass:removeAll()
   for i, v in ipairs(ActiveGrass) do
      v.physics.body:destroy()
   end

   ActiveGrass = {}
end

function Grass:update(dt)

    --if Contact
    if self.isContact then
        for i,instance in ipairs(ActiveGrass) do
            if instance == self then
                test = "collision"
            end
         end
    else
          test = "not collision"  
    end
end


function Grass:draw()
      love.graphics.polygon("line", self.physics.body:getWorldPoints(self.physics.shape:getPoints())) 
end

function Grass.updateAll(dt)
   for i,instance in ipairs(ActiveGrass) do
      instance:update(dt)
   end
end

function Grass.drawAll()
   for i,instance in ipairs(ActiveGrass) do
      instance:draw()
   end
end

--Check Contact
function Grass.beginContact(a, b, collision)
   for i,instance in ipairs(ActiveGrass) do
      if a == instance.physics.fixture or b == instance.physics.fixture then
         if a == Car.physics.fixture or b == Car.physics.fixture then
            instance.isContact = true
            return true
         end
      end
   end
end


function Grass.endContact(a,b,collision)
    for i,instance in ipairs(ActiveGrass) do
        if a == instance.physics.fixture or b == instance.physics.fixture then
           if a == Car.physics.fixture or b == Car.physics.fixture then
              instance.isContact = false
              return true
           end
        end
     end
end