require("car")
require("joystick")
require("mainMenu")
require("map")
require("Touches")
require("grass")
require("gameplayButtons")

love.graphics.setDefaultFilter("nearest", "nearest")
local STI = require("libraries/sti")



function love.load()
    Map:load()
    test = "not collision"
    levelState = "Main Menu"
    MainMenu:load()
    GMbuttons:load()
    Joystick:load() 
    Car:load()
end

function love.update(dt)
    Touches:update(dt)

    if levelState == "Main Menu" then
        MainMenu:update(dt) 
    elseif levelState == "PVA" then
        World:update(dt)
        Grass.updateAll(dt)
        GMbuttons:update(dt)
        Joystick:update(dt) 
        Car:update(dt)
    end
end


 
function love.touchpressed( id, x, y, dx, dy, pressure )       
    if levelState == "Main Menu" and
     x >= MainMenu.buttonPVA.x and 
     x <= MainMenu.buttonPVA.x + MainMenu.buttonPVA.width and 
     y >= MainMenu.buttonPVA.y and 
     y <= MainMenu.buttonPVA.y + MainMenu.buttonPVA.height then
      levelState = "PVA"
    end

    
end

function love.mousepressed(x, y, button, istouch)
    if levelState == "Main Menu" and
     x >= MainMenu.buttonPVA.x and 
     x <= MainMenu.buttonPVA.x + MainMenu.buttonPVA.width and 
     y >= MainMenu.buttonPVA.y and 
     y <= MainMenu.buttonPVA.y + MainMenu.buttonPVA.height then
      levelState = "PVA"
    end

    if 
     x >= GMbuttons.NitroButton.x - 50 and 
     x <= GMbuttons.NitroButton.x + GMbuttons.NitroButton.radius and
     y >= GMbuttons.NitroButton.y - 50 and 
        y <= GMbuttons.NitroButton.y + GMbuttons.NitroButton.radius and 
        levelState == "PVA" and
        Joystick.isActive and 
        Car.nitroFuel > 0 then
        Car.accel = 650
        Car.max_speed = 200
        Car.nitroFuel = Car.nitroFuel - 5
        Car.isNitro = true
    else
        --Car.accel = 400
        Car.max_speed = 120
        Car.speed = 0
        Car.isNitro = false    
    end

    if 
        x >= Joystick.x - 100 and 
        x <= Joystick.x + Joystick.radius + 30 and
        y >= Joystick.y - 100 and 
        y <= Joystick.y + Joystick.radius + 30 then
            Joystick.isActive = true
            Joystick:Following(x,y)
            Joystick.isDown = true    
        end
end

function love.mousemoved( x, y, dx, dy, istouch )
	if Joystick.isActive then
        local angle = math.atan2(y - Joystick.y, x - Joystick.x)
        local distance = math.min(math.sqrt(Joystick.distanceX^2 + Joystick.distanceY^2), Joystick.radius)
        if distance <= Joystick.radius - Joystick.handleRadius then
            -- Joystick handle is completely inside the joystick area
            Joystick.handleX = x
            Joystick.handleY = y 
        else
            -- Joystick handle is at the edge of the joystick area
            Joystick.handleX = Joystick.x + (Joystick.radius + 30 - Joystick.handleRadius) * math.cos(angle) 
            Joystick.handleY = Joystick.y + (Joystick.radius + 30 - Joystick.handleRadius) * math.sin(angle) 
        end
  
        -- Normalize the joystick handle position to get values between -1 and 1
        local normalizedX = (Joystick.handleX - Joystick.x) 
        local normalizedY = (Joystick.handleY - Joystick.y)
  
        -- Update car controls based on joystick input
        Car.angle = math.atan2(normalizedY, normalizedX)
        Car.speed = Car.max_speed * math.sqrt(normalizedX ^ 2 + normalizedY ^ 2)
    end
end

function love.mousereleased(x, y, button)
     -- Deactivate joystick when touch is released
     Joystick.isActive = false

     -- Reset joystick handle position
     Joystick.handleX = Joystick.x
     Joystick.handleY = Joystick.y
end

function love.touchmoved(id, x, y, dx, dy, pressure)
    -- Update joystick handle position when dragging
    if Joystick.isActive then
        local angle = math.atan2(y - Joystick.y, x - Joystick.x)
        local distance = math.min(math.sqrt(Joystick.distanceX^2 + Joystick.distanceY^2), Joystick.radius)
        if distance <= Joystick.radius - Joystick.handleRadius then
            -- Joystick handle is completely inside the joystick area
            Joystick.handleX = x
            Joystick.handleY = y 
        else
            -- Joystick handle is at the edge of the joystick area
            Joystick.handleX = Joystick.x + (Joystick.radius + 30 - Joystick.handleRadius) * math.cos(angle) 
            Joystick.handleY = Joystick.y + (Joystick.radius + 30 - Joystick.handleRadius) * math.sin(angle) 
        end
  
        -- Normalize the joystick handle position to get values between -1 and 1
        local normalizedX = (Joystick.handleX - Joystick.x) 
        local normalizedY = (Joystick.handleY - Joystick.y)
  
        -- Update car controls based on joystick input
        Car.angle = math.atan2(normalizedY, normalizedX)
        Car.speed = Car.max_speed * math.sqrt(normalizedX ^ 2 + normalizedY ^ 2)
    end
  end

function love.touchreleased( id, x, y, dx, dy, pressure )
    -- Deactivate joystick when touch is released
    Joystick.isActive = false

  -- Reset joystick handle position
  Joystick.handleX = Joystick.x
  Joystick.handleY = Joystick.y
end



function love.draw()
    if levelState == "Main Menu" then
        MainMenu:draw()
    elseif levelState == "PVA" then
        love.graphics.scale(0.5,0.5)
        Map.level:drawLayer(Map.level.layers["Grass"])
        Map.level:drawLayer(Map.level.layers["Road"])
        Map.level:drawLayer(Map.level.layers["Border"])
        Map.level:drawLayer(Map.level.layers["Finish"])
        Grass.drawAll()

        love.graphics.reset()
        love.graphics.print(test,0,60)
        --love.graphics.print(Car.accel,0,0)
        --love.graphics.print(Car.max_speed,0,20)
        --love.graphics.print(Car.nitroFuel,0,40)
        GMbuttons:draw()
        love.graphics.setColor(0,0,0)
        love.graphics.arc( "line","open", GMbuttons.NitroButton.x, GMbuttons.NitroButton.y, 35, 0, math.rad(Car.nitroFuel) )
        love.graphics.reset()
        Joystick:draw()
        Car:draw()
    end
end


function beginContact(a,b,collision)
    if Grass.beginContact(a,b,collision) then return end
end

function endContact(a,b,collision)
   if Grass.endContact(a,b,collision) then return end
end