Map = {}
local STI = require("libraries/sti")


function Map:load()
    self.currentLevel = 2
    World = love.physics.newWorld(0,0)
    World:setCallbacks(beginContact,endContact)    
    self:init()
end

function Map:init()
    self.level = STI("Levels/Level"..self.currentLevel..".lua", {"box2d"})
    self.level:box2d_init(World)
    self.level.layers.solid.visible = true
    self.level.layers.entity.visible = false

    self.spawnEntities()
end

function Map:next()
    self:clean()
    self.currentLevel = 2
    self:init()
end

function Map:clean()
    self.level:box2d_removeLayer("solid")
    self.level:box2d_removeLayer("entity")

    Grass:removeAll()
    
end

function Map:spawnEntities()
    for k, v in ipairs(Map.level.layers.entity.objects) do
        if v.type == "grass" then
            Grass.new(v.x + v.width / 2, v.y + v.height / 2,v.width,v.height)
        end
    end
end



return Map